*! version 1.1.3  02may2005  by Marc Muendler  muendler@ucsd.edu

global blcut 17.5  /* Higher-school attainment Germany, West */

tempfile dist
use "$root/conc/fdi-iso-country", clear
keep buba iso3code
rename buba country
replace iso3code = upper(trim(iso3code))
sort iso3code
merge iso3code using "$root/countries/dist-deu"
tab _m
drop if countr==.
drop if dist==.
count if _m~=3
if `r(N)'>0 {
  disp as err "Missing distance information"
  STOP
  }
keep country dist lndist
rename lndist ln_dist
sort country
compress
save `dist'

use "$root/countries/extdata-deflated", clear
keep if year==$year
keep gdp_ppp gdp_cap_ppp consum_expend_ppp cons_cap_ppp country population
merge country using `dist'
tab _m
drop _m
sort country
save ${wdi}

* country list for later use
insheet using "$root/conc/direk-cntrylist.csv", comma names clear
sort country
save ${cntrylst}
