*! version 1.0.5  22mar2006  by Marc Muendler  muendler@ucsd.edu

clear
set memory 400m
set matsize 400
set more off
capture log close

cd "$rootslct"

log using "logs/translog-selct-2stp-$waglvl-pt$par-af$aff-cf-nonparam-relaxed-graph-allyrs.log", replace

capture mkdir "$rootslct/graphs"
capture mkdir "$rootslct/graphs/v6nprfs"
capture mkdir "$rootslct/graphs/v6nprfs/pt$par-af$aff-cf"

#delimit ;

/* variable sets for selection estimation */
/*----------------------------------------*/

do $dp/!varsets-np.do;

tokenize ${paruse};
local regrno : word count ${paruse};

/* load data */
/*-----------*/

use "$rootslct/Xdata/mneid-fortwoway-$waglvl-pt$par-af$aff-cf-nonparam-relaxed-allyrs", clear;

/* first step: non-parametric selection estimation */
/*-------------------------------------------------*/
  foreach reg in $regagg {;
    local r2dg = substr("`reg'",1,2);
      foreach wreg in HOM $regagg {;
        local predacc "_b[_cons]";  /* predicted poynomial terms, varying only by `wreg' wage (all other vars are sample means) */
        local restavgacc "`secavgdum' + _b[iCE96]*_MNiCE96 + _b[iDE96]*_MNiDE96 + _b[iOI96]*_MNiOI96 + _b[iWE96]*_MNiWE96";  /* predicted remaining terms, not varying (sample means) */
        local restacc "`secdum' + _b[iCE96]*iCE96 + _b[iDE96]*iDE96 + _b[iOI96]*iOI96 + _b[iWE96]*iWE96";  /* predicted remaining terms, varying by all variables for standard error calculation */
        local matacc "0";  /* marginal effect of `wreg' wage */
        * local chkacc "`predacc' + `restacc'";  /* for consistency checks (disabled) */
        local w2dg = substr("`wreg'",1,2);
        local regvar = "w_othr_`wreg'";
        if "`wreg'"=="HOM"  local regvar = "w_`wreg'";
        forvalues i = 1/`regrno' {;
          if length(subinstr("``i''","`wreg'","",.)) < length("``i''") {;  /* wage variable appears in token: treat */
            if lower(subinstr("``i''","`wreg'","",.)) == subinstr("``i''","`wreg'","",.) & substr(subinstr("``i''","`wreg'","",.),-1,1)=="_" {;  /* only `wreg' terms appear in token */
              local predacc "`predacc' + _b[``i'']*``i''";
              if length(subinstr("``i''","`wreg'","",.)) == length("``i''")-3  local matacc "`matacc' + _b[``i'']";
              if length(subinstr("``i''","`wreg'","",.)) == length("``i''")-6  local matacc "`matacc' + 2*_b[``i'']*`regvar'";
              if length(subinstr("``i''","`wreg'","",.)) == length("``i''")-9  local matacc "`matacc' + 3*_b[``i'']*w_`wreg'_`wreg'";
              * local chkacc "`chkacc' + _b[``i'']*``i''";
              };
            else {; /* mixed `wreg' and other terms appear in token */
              local covar = "_MN" + subinstr(subinstr(subinstr(subinstr("``i''","`wreg'","",.),"__","_",.),"__","_",.),"othr_","",.);
              if substr("`covar'",-1,1)=="_"  local covar = substr("`covar'",1,length("`covar'")-1);
              if lower(subinstr("`covar'","_MN","",.))==subinstr("`covar'","_MN","",.) & length("`covar'")<=12  local covar = subinstr("`covar'","w_","ln_",.);
              if lower(subinstr("`covar'","_MN","",.))==subinstr("`covar'","_MN","",.) & length("`covar'") >12  local covar = subinstr("`covar'","w_","",.);
              if length(subinstr("``i''","`wreg'","",.)) == length("``i''")-3  local predacc "`predacc' + _b[``i'']*`regvar'*`covar'";
              if length(subinstr("``i''","`wreg'","",.)) == length("``i''")-6  local predacc "`predacc' + _b[``i'']*w_`wreg'_`wreg'*`covar'";
              if length(subinstr("``i''","`wreg'","",.)) == length("``i''")-3  local matacc "`matacc' + _b[``i'']*`covar'";
              if length(subinstr("``i''","`wreg'","",.)) == length("``i''")-6  local matacc "`matacc' + 2*_b[``i'']*`regvar'*`covar'";
              * local chkacc "`chkacc' + _b[``i'']*``i''";
              };
            };
          if length(subinstr("``i''","`wreg'","",.)) == length("``i''") {;  /* wage variable does not appear in token: store for mean subtraction */
            local exclvar = subinstr("``i''","othr_","",.);
            local restavgacc "`restavgacc' + _b[``i'']*_MN`exclvar'";
            local restacc "`restacc' + _b[``i'']*``i''";
            * local chkacc "`chkacc' + _b[``i'']*``i''";
            };
          };
        di; di in green "predacc for psc`r2dg', w`w2dg':"; disp in yellow "`predacc'"; 
        di; di in green "restacc for psc`r2dg', w`w2dg':"; disp in yellow "`restacc'"; 
        di; di in green "restavgacc for psc`r2dg', w`w2dg':"; disp in yellow "`restavgacc'"; 
        di; di in green "matacc for psc`r2dg', w`w2dg':"; disp in yellow "`matacc'";
        di;
        sort `regvar';
        twoway connected dpsc`r2dg'dw`w2dg' dpsc`r2dg'dw`w2dg'_lcl dpsc`r2dg'dw`w2dg'_ucl `regvar';
        graph export "$rootslct/graphs/v6nprfs/pt$par-af$aff-cf/dpsc`r2dg'dw`w2dg'-ci.eps", replace;
        twoway connected dpsc`r2dg'dw`w2dg' `regvar';
        graph export "$rootslct/graphs/v6nprfs/pt$par-af$aff-cf/dpsc`r2dg'dw`w2dg'.eps", replace;
        }; /* close wreg loop */
    };  /* close reg loop */


/* second step: seemingly unrelated regressions with nonparametric error terms */
/*-----------------------------------------------------------------------------*/
foreach reg in $regagg {;
  local r2dg = substr("`reg'",1,2);
  * Evaluation of selection effects;
  foreach wreg in $regagg {;
    local w2dg = substr("`wreg'",1,2);
    local pspredacc "_b[s`r2dg':_cons]"; 
    local psrestacc "0";
    local psrestavgacc "0";
    local pspredacc "`pspredacc' + _b[s`r2dg':psc`w2dg']*psc`w2dg'";
    local psmatacc "_b[s`r2dg':psc`w2dg']";
    tokenize `pscser'; 
    local regrno : word count `pscser';
    forvalues i = 1/`regrno' {;
      if length(subinstr("``i''","`w2dg'","",.)) == length("``i''")-6 {; /* regional variable appears in cubic term: treat */
        local pspredacc "`pspredacc' + _b[s`r2dg':``i'']*psc`w2dg'*psc`w2dg'*psc`w2dg'";
        local psmatacc "`psmatacc' + 3*_b[s`r2dg':``i'']*psc`w2dg'*psc`w2dg'";
        };
      if length(subinstr("``i''","`w2dg'","",.)) == length("``i''")-4 & lower(subinstr("``i''","`w2dg'","",.))~=subinstr("``i''","`w2dg'","",.) {; /* regional variable appears in third-order interaction term: treat */
        local covar = subinstr(subinstr("``i''","`w2dg'","",.),"_","",.);
        local pspredacc "`pspredacc' + _b[s`r2dg':``i'']*__avg_`covar'*psc`w2dg'*psc`w2dg'";
        local psmatacc "`psmatacc' + 2*_b[s`r2dg':``i'']*__avg_`covar'*psc`w2dg'";
        };
      if length(subinstr("``i''","`w2dg'","",.)) == length("``i''")-2 & lower(subinstr("``i''","`w2dg'","",.))~=subinstr("``i''","`w2dg'","",.) {; /* regional variable appears in second-order interaction term: treat */
        local covar1 = "psc" + substr(subinstr(subinstr("``i''","`w2dg'","",.),"_","",.),4,2);
        local covar2 = "psc" + substr(subinstr(subinstr("``i''","`w2dg'","",.),"_","",.),6,2);
        if "`covar2'"=="psc" {;
          local pspredacc "`pspredacc' + _b[s`r2dg':``i'']*__avg_`covar1'*psc`w2dg'";
          local psmatacc "`psmatacc' + _b[s`r2dg':``i'']*__avg_`covar1'";
          };
        if "`covar2'"~="psc" {;
          local pspredacc "`pspredacc' + _b[s`r2dg':``i'']*__avg_`covar1'*__avg_`covar2'*psc`w2dg'";
          local psmatacc "`psmatacc' + _b[s`r2dg':``i'']*__avg_`covar1'*__avg_`covar2'";
          };
        };
      if length(subinstr("``i''","`w2dg'","",.)) == length("``i''") {; /* regional variable does not appear in term: store for mean subtraction */
        local psrestacc "`psrestacc' + _b[``i'']*``i''";
        local psrestavgacc "`psrestavgacc' + _b[``i'']*__avg_``i''";
        };
      };     
    di; di in green "predacc for y`r2dg', ps`w2dg':"; disp in yellow "`pspredacc'"; 
    di; di in green "psrestacc for y`r2dg', ps`w2dg':"; disp in yellow "`psrestacc'"; 
    di; di in green "psrestavgacc for y`r2dg', ps`w2dg':"; disp in yellow "`psrestavgacc'"; 
    di; di in green "psmatacc for y`r2dg', ps`w2dg':"; disp in yellow "`psmatacc'"; 
    di;
    sort psc`w2dg';
    twoway connected dy`r2dg'dps`w2dg' dy`r2dg'dps`w2dg'_lcl dy`r2dg'dps`w2dg'_ucl psc`w2dg' if psc`w2dg'>=0 & psc`w2dg'<=1;
    graph export "$rootslct/graphs/v6nprfs/pt$par-af$aff-cf/dy`r2dg'dps`w2dg'-ci.eps", replace;
    twoway connected dy`r2dg'dps`w2dg' psc`w2dg' if psc`w2dg'>=0 & psc`w2dg'<=1;
    graph export "$rootslct/graphs/v6nprfs/pt$par-af$aff-cf/dy`r2dg'dps`w2dg'.eps", replace;
    }; /* close wreg loop */
  }; /* close reg loop */

log close;
cd "$root";
